<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class Banco {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function buscaBancos(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_BANCOS);
	}

	public function buscaBancoEspecifico($CDBANCO){
		$params = array(
			':CDBANCO' => $CDBANCO
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_BANCO_ESPECIFICO, $params);
	}

	public function atualizaBanco($CDBANCO, $DSINSCEMPVND, $QTDIASVENVND, $CDAGENCIAVND, $CDCONTCORVND, $CDCONTRATOVND, $CDBANCOCONVVND){
		$params = array(
			':CDBANCO'      => $CDBANCO,
			':DSINSCEMPVND' => $DSINSCEMPVND,
			':QTDIASVENVND' => $QTDIASVENVND,
			':CDAGENCIAVND' => $CDAGENCIAVND,
			':CDCONTCORVND' => $CDCONTCORVND,
			':CDCONTRATOVND'=> $CDCONTRATOVND,
			':CDBANCOCONVVND'  => $CDBANCOCONVVND
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_BANCO, $params);
	}

	public function buscaAgencias($CDBANCO){
		$params = array(
			':CDBANCO' => $CDBANCO,
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_AGENCIAS, $params);
	}

	public function buscaContas($CDBANCO, $CDAGENCIA){
		$params = array(
			':CDBANCO' => $CDBANCO,
			':CDAGENCIA' => $CDAGENCIA
		);		

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_CONTAS, $params);
	}
	
	public function buscaMascara($CDBANCO){
		$params = array(
			':CDBANCO' => $CDBANCO,
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_MASCARA, $params);
	}
	
	public function buscaBanco($CDBANCO){
		$params = array(
			':CDBANCO' => $CDBANCO,
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_BANCO, $params);
	}

	public function getBlockedCards(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_BLOCKED_CARDS, array());
	}

	public function getBlockedCard($NRPRIMEIROS, $NRULTIMOS){
		$params = array(
			':NRPRIMEIROS' => $NRPRIMEIROS,
			':NRULTIMOS' => $NRULTIMOS
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_BLOCKED_CARD, $params);
	}

	public function addBlockedCard($NRSEQCARTAOBLOQ, $NRPRIMEIROS, $NRULTIMOS, $DESCCARTAO){
		$params = array(
			':NRSEQCARTAOBLOQ' => $NRSEQCARTAOBLOQ,
			':NRPRIMEIROS' => $NRPRIMEIROS,
			':NRULTIMOS' => $NRULTIMOS,
			':DESCCARTAO' => $DESCCARTAO
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::ADD_BLOCKED_CARD, $params);
	}

	public function updateBlockedCard($NRSEQCARTAOBLOQ, $NRPRIMEIROS, $NRULTIMOS, $DESCCARTAO){
		$params = array(
			':NRSEQCARTAOBLOQ' => $NRSEQCARTAOBLOQ,
			':NRPRIMEIROS' => $NRPRIMEIROS,
			':NRULTIMOS' => $NRULTIMOS,
			':DESCCARTAO' => $DESCCARTAO
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_BLOCKED_CARD, $params);
	}

	public function deleteBlockedCard($NRSEQCARTAOBLOQ){
		$params = array(
			':NRSEQCARTAOBLOQ' => $NRSEQCARTAOBLOQ,
		);
		$this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_BLOCKED_CARD, $params);
	}

}